// $Id: ConnInfo.cc,v 1.4.2.1 1998/09/22 07:43:22 rousskov Exp $

/*
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation, and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#include "AppDef.h"

#include "ConnInfo.h"

int ConnInfo::TheLastId = 0;

enum Dir { dirNone, dirIn, dirOut };

ConnInfo::ConnInfo(ResOwner *owner, Connection *aConn):
	theConn(aConn), theInMgr(0), theOutMgr(0), theUseCount(0),
	theId(++TheLastId), theIdx(-1) {

	assert(theConn);
	theInMgr = new ResMgr(owner);
	theOutMgr = new ResMgr(owner);
	theInMgr->resId(id());
	theOutMgr->resId(id());
}

ConnInfo::~ConnInfo() {
	delete theInMgr;
	delete theOutMgr;
	delete theConn;
}

ConnMx ConnInfo::getMx(Dir dir) {
	return ConnMx(
		(dir == dirIn) ? theInMgr->getMx() : theOutMgr->getMx(),
		theConn);
}
