// $Id: StatShooters.cc,v 1.4.2.1 1998/09/22 07:43:43 rousskov Exp $

/*
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation, and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#include "StatShooters.h"

#include <iostream.h>
#include <iomanip.h>

EvCntShooter::EvCntShooter(EventCounter *aCounter, Name aName):
	Shooter(aName, sizeof(EventCounter), (char*)aCounter),
	theCounter(aCounter) {
}

ostream &EvCntShooter::print(ostream &os) const {
	assert(theCounter);
	return os << *theCounter;
}

EvShCntShooter::EvShCntShooter(EventShortCounter *aCounter, Name aName):
	Shooter(aName, sizeof(EventShortCounter), (char*)aCounter),
	theCounter(aCounter) {
}

ostream &EvShCntShooter::print(ostream &os) const {
	assert(theCounter);
	return os << *theCounter;
}

/* LvlMtrShooter */

LvlMtrShooter::LvlMtrShooter(LevelMeter *aMeter, Name aName):
	Shooter(aName, 5*sizeof(int), (char*)aMeter),
	theMeter(aMeter) {
}

ostream &LvlMtrShooter::print(ostream &os) const {
	assert(theMeter);
	return os
		<< setw(3) << theMeter->first()
		<< setw(3) << theMeter->last()
		<< setw(3) << theMeter->hi()
		<< setw(3) << theMeter->lo();
}

void LvlMtrShooter::hton(char *buf) const {
	hton32(buf);
	hton32(buf += 4);
	hton32(buf += 4);
	hton32(buf += 4);
}

void LvlMtrShooter::ntoh(char *buf) const {
	ntoh32(buf);
	ntoh32(buf += 4);
	ntoh32(buf += 4);
	ntoh32(buf += 4);
}
