#ifndef _CLOCK_CLASS_H_
#define _CLOCK_CLASS_H_ "$Id: Clock.h,v 1.3.2.1 1998/09/22 07:43:59 rousskov Exp $"

/*
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation, and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#include "Time.h"

// an object that can show current time and 
// responds to time changes (to sync with other clocks)

class Clock {
	public:
		Clock();
		virtual ~Clock();

		Time time() const { return theCurTime; }
		operator Time() const { return time(); }

		Time now() { update(Time::Now()); return time(); }
		virtual void update(Time aCurTime) { theCurTime = aCurTime; }

	protected:
		Time theCurTime;
};

// get current time, maybe advance all clocks, return time since last update
extern Time UpdateClocks(bool advanceAll = true);

// Wall Clock -- "official Clock" (it is always advanced by UpdateClocks())
extern Clock TheClock;


// internal object to initialize Clock library, ignore
class ClockLibCounter {
	public:
		ClockLibCounter();
		~ClockLibCounter();
	protected:
		static int theUseCount;
};
static ClockLibCounter TheClockLibCounter;

#endif
