#ifndef _LIMIT_PGS_METER_H_
#define _LIMIT_PGS_METER_H_ "$Id: LimitPgsMeter.h,v 1.2.2.1 1998/09/22 07:44:10 rousskov Exp $"

/*
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation, and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#include "ProgressMeter.h"

// limits progress to a given number of started and/or finished tasks
// limit of -1 means no limit

class LimitPgsMeter: public ProgressMeter {
	public:
		LimitPgsMeter(int aStartLimit, int aFinishLimit): theStartLimit(aStartLimit), theFinishLimit(aFinishLimit) {}

		virtual ProgressMeter *clone() const { return new LimitPgsMeter(theStartLimit, theFinishLimit); }
		virtual bool enough() const { return
			(theStartLimit >= 0 && theStartCount >= theStartLimit) ||
			(theFinishLimit >= 0 && theFinishCount >= theFinishLimit); }

	protected:
		int theStartLimit;
		int theFinishLimit;									
};

#endif
