#ifndef _RND_REP_MAKER_H_
#define _RND_REP_MAKER_H_ "$Id: RndRepMaker.h,v 1.11.2.2 1998/10/01 19:11:20 rousskov Exp $"

/*
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation, and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#include "AppDef.h"

#include "RepMaker.h"
#include "AlarmClock.h"
#include "RepCBlock.h"

// creates reply with a random content

class RndRepMaker: public RepMaker, public Sleeper {
	public:
		RndRepMaker(Size aMaxBufSize, bool aPersFlag): theMaxBufSize(aMaxBufSize), thePersFlag(aPersFlag), theSleepState(ssAwake) {}

		virtual Thread *clone() const { return new RndRepMaker(theMaxBufSize, thePersFlag); }

		virtual void init() { RepMaker::init(); workBuf().minCapacity(theMaxBufSize); }

		virtual void wakeUp(const Alarm &) { theSleepState = ssSlept; beActive(thRunnable); }

	protected:
		virtual Size workOffset() const { return theConn->theWriterBuf.inOffset(); }
		virtual IOBuffer &workBuf() const { return theConn->theWriterBuf; }

		Size calcRepSize() const;
		void make200Prefix();
		void make304Prefix();
		virtual void doContent();

	protected:
		RepCBlock theCBlock;
		Size theMaxBufSize;
		bool thePersFlag;

		enum { ssAwake, ssSleeping, ssSlept } theSleepState;
};

#endif
