// $Id: StatShooters.h,v 1.3.2.1 1998/09/22 07:44:28 rousskov Exp $

/*
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation, and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#ifndef _STAT_SHOOTERS_H_
#define _STAT_SHOOTERS_H_

#include "Stats.h"
#include "Shooter.h"
#include "Gadgets.h"

// EventCounter shooter
class EvCntShooter: public Shooter {
	public:
		EvCntShooter(EventCounter *aCounter, Name aName);
		virtual ~EvCntShooter() {}

		virtual void hton(char *buf) const { hton32(buf); }
		virtual void ntoh(char *buf) const { ntoh32(buf); }

		virtual ostream &print(ostream &os) const;

	protected:
		EventCounter *theCounter;
};

// EventShortCounter shooter
class EvShCntShooter: public Shooter {
	public:
		EvShCntShooter(EventShortCounter *aCounter, Name aName);
		virtual ~EvShCntShooter() {}

		virtual void hton(char *buf) const { hton16(buf); }
		virtual void ntoh(char *buf) const { ntoh16(buf); }

		virtual ostream &print(ostream &os) const;

	protected:
		EventShortCounter *theCounter;
};

typedef EvCntShooter ValStShooter;

// LevelMeter shooter
class LvlMtrShooter: public Shooter {
	public:
		LvlMtrShooter(LevelMeter *aMeter, Name aName);
		virtual ~LvlMtrShooter() {}

		virtual void hton(char *buf) const;
		virtual void ntoh(char *buf) const;

		virtual ostream &print(ostream &os) const;

	protected:
		LevelMeter *theMeter;
};

#endif
